/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Translation Panel,Find in Statusbar,Yahoo TV,and other Nazo's Extensions.
 *
 * The Initial Developer of the Original Code is Nazo.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *    Nazo <lovesyao at hotmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function nzPref(){}

nzPref.prototype={
  _prefsI:Components.interfaces.nsIPrefBranch,
  _prefs:Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch),
  TYPE_BOOL:128,
  TYPE_INT:64,
  TYPE_STRING:32,
  get contractID(){
    return "@nazo/pref;1.1";
  },
  get classDescription(){
    return "PREF";
  },
  get classID(){
    return Components.ID("{8A127C1D-9317-47c0-B59D-330ADA4FA716}");
  },
  setRoot:function(aID){
    this.fullName="extensions."+aID;
    this.name=aID;
    return void(0);
  },
  getChild:function(aName){
    if(!this.fullName){
      throw new Error("Not initialized.")
    }
    var result=new nzPref();
    result.fullName=this.fullName+"."+aName;
    result.name=aName;
    return result;
  },
  set value(aVal){
    if(!this.fullName){
      throw new Error("Not initialized.")
    }
    if(aVal==null){
      this._prefs.clearUserPref(this.fullName);
      return void(0);
    }
    switch(typeof(aVal)) {
      case "boolean":
        this._prefs.setBoolPref(this.fullName,aVal);
        break;
      case "number":
        this._prefs.setIntPref(this.fullName,aVal);
        break;
      case "string":
        var value = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        value.data = aVal;
        this._prefs.setComplexValue(this.fullName,Components.interfaces.nsISupportsString,value);
        break;
      default:
        throw new Error("Unsupported type "+typeof(aVal)+" for preference "+this.fullName);
    }
    return void(0);
  },
  get value(){
    if(!this.fullName){
      throw new Error("Not initialized.")
    }
    try{
      switch (this.type) {
        case this._prefsI.PREF_STRING:
          var re = this._prefs.getComplexValue(this.fullName,Components.interfaces.nsISupportsString).data;
          try{
            if(/^chrome:\/\/.+\/locale\/.+\.properties/.test(re)){
              re=this._prefs.getComplexValue(this.fullName,Components.interfaces.nsIPrefLocalizedString).data;
            }
          }catch(e){};
          return re;
        case this._prefsI.PREF_INT:
          return this._prefs.getIntPref(this.fullName);
        case this._prefsI.PREF_BOOL:
          return this._prefs.getBoolPref(this.fullName);
      }
    }catch(e){}
    return null;
  },
  get type(){
    if(!this.fullName){
      throw new Error("Not initialized.")
    }
    return this._prefs.getPrefType(this.fullName);
  },
  QueryInterface:function(aIID){
    if(!aIID.equals(Components.interfaces.nzIPref) && !aIID.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
}



var gModule = {
  _firstTime: true,
  registerSelf: function (aComponentManager, aFileSpec, aLocation, aType) 
  {
    if (this._firstTime) {
      this._firstTime = false;
      throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
    }
    aComponentManager = aComponentManager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.registerFactoryLocation(obj.CID, obj.className, obj.contractID, aFileSpec, aLocation, aType);
    }
  },
  getClassObject: function (aComponentManager, aCID, aIID) 
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    for (var key in this._objects) {
      if (aCID.equals(this._objects[key].CID))
        return this._objects[key].factory;
    }
    
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },
  
  _objects: {
    manager: { CID        : nzPref.prototype.classID,
               contractID : nzPref.prototype.contractID,
               className  : nzPref.prototype.classDescription,
               factory    : {
                              createInstance: function (aOuter, aIID) 
                              {
                                if (aOuter != null)
                                  throw Components.results.NS_ERROR_NO_AGGREGATION;
                                return (new nzPref()).QueryInterface(aIID);
                              }
                            }
             }
   },
  
  canUnload: function (aComponentManager) 
  {
    return true;
  }
};

function NSGetModule(compMgr, fileSpec) 
{
  return gModule;
}