/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Translation Panel,Find in Statusbar,Yahoo TV,and other Nazo's Extensions.
 *
 * The Initial Developer of the Original Code is Nazo.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *    Nazo <lovesyao at hotmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

function nzRunningApp(){}

nzRunningApp.prototype = {
  get contractID(){
    return "@nazo/runapp;1";
  },
  get classDescription(){
    return "Running Application";
  },
  get classID(){
    return Components.ID("{56C7E6F4-6DB7-4C86-B9E1-8A960F5D5BB5}");
  },
  init: function(aID){
    this._id = aID;
    return void(0);
  },
  getApp: function(){
    if (!this._id) {
      throw new Error("Not initialized.")
    }
    id=Components.classes["@mozilla.org/xre/app-info;1"]
           .getService(Components.interfaces.nsIXULAppInfo).ID;
    switch(id){
      case this._id:
        return Components.interfaces.nzIRunningApp.XULRUNNER;
      case "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}":
        return Components.interfaces.nzIRunningApp.FIREFOX;
      case "{3550f703-e582-4d05-9a08-453d09bdfdc6}":
        return Components.interfaces.nzIRunningApp.THUNDERBIRD;
      case "{718e30fb-e89b-41dd-9da7-e25a45638b28}":
        return Components.interfaces.nzIRunningApp.SUNBIRD;
      case "{136c295a-4a5a-41cf-bf24-5cee526720d5}":
        return Components.interfaces.nzIRunningApp.NVU;
      case "{86c18b42-e466-45a9-ae7a-9b95ba6f5640}":
        return Components.interfaces.nzIRunningApp.MOZILLASUITE;
      case "{3db10fab-e461-4c80-8b97-957ad5f8ea47}":
        return Components.interfaces.nzIRunningApp.NETSCAPE;
      default:
        return Components.interfaces.nzIRunningApp.UNKNOWN;
    }
  },
  isApp: function(aApp){
      return (aApp==this.getApp());
  },
  QueryInterface: function(aIID){
    if (!aIID.equals(Components.interfaces.nzIRunningApp) 
          && !aIID.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
}



var gModule = {
  _firstTime: true,
  registerSelf: function (aComponentManager, aFileSpec, aLocation, aType) 
  {
    if (this._firstTime) {
      this._firstTime = false;
      throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
    }
    aComponentManager = aComponentManager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.registerFactoryLocation(obj.CID, obj.className, obj.contractID, aFileSpec, aLocation, aType);
    }
  },
  getClassObject: function (aComponentManager, aCID, aIID) 
  {
    if (!aIID.equals(Components.interfaces.nsIFactory))
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    for (var key in this._objects) {
      if (aCID.equals(this._objects[key].CID))
        return this._objects[key].factory;
    }
    
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },
  
  _objects: {
    manager: { CID        : nzRunningApp.prototype.classID,
               contractID : nzRunningApp.prototype.contractID,
               className  : nzRunningApp.prototype.classDescription,
               factory    : {
                              createInstance: function (aOuter, aIID) 
                              {
                                if (aOuter != null)
                                  throw Components.results.NS_ERROR_NO_AGGREGATION;
                                return (new nzRunningApp()).QueryInterface(aIID);
                              }
                            }
             }
   },
  
  canUnload: function (aComponentManager) 
  {
    return true;
  }
};

function NSGetModule(compMgr, fileSpec) 
{
  return gModule;
}
